(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Arial", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Arial", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Arial", 14, L0, center, nohscroll, bold;
	fontset = section, "Arial", 14, L0, bold, grayBox;
	fontset = subsection, "Arial", 12, L0, bold, blackBox;
	fontset = subsubsection, "Arial", 10, L0, bold, whiteBox;
	fontset = text, "Arial", 12, L0;
	fontset = smalltext, "Arial", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65280;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Arial", 10, L0, nohscroll, italic, B65280;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Arial", 10, L0, nohscroll;
	fontset = clipboard, "Arial", 12, L0, nohscroll;
	fontset = completions, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Arial", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Arial", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = title; inactive; initialization; nohscroll; center; ]
*)
Finite Volume Method
(*
:[font = subtitle; inactive; nohscroll; center; ]

(Local Approximation Study)
:[font = name; inactive; nohscroll; ]

                                    Victor G. Ganzha and Evgenii V. Vorozhtsov
:[font = section; inactive; ]
Impressum
:[font = special4; inactive; nowordwrap; nohscroll; ]
This Mathematica-Notebook is part of the book entitled
                                  V.G.Ganzha and E.V.Vorozhtsov
  Numerical Solutions For Partial Differential Equations: Problem Solving
  Using Mathematica.  CRC Press, Boca Raton, Ann Arbor, 1996.

:[font = subsection; inactive; ]
Copyright
:[font = special4; inactive; nowordwrap; nohscroll; ]

 Numerical Solutions For Partial Differential Equations: Problem Solving
 Using Mathematica.  CRC Press, Boca Raton, Ann Arbor, 1996.

:[font = section; inactive; ]
General Description
:[font = special4; inactive; nowordwrap; nohscroll; ]

The program appr2.ma which follows below enables one to compute 
 the symbolic expression for the leading terms of the truncation error  
 of the finite volume approximation of the partial derivative of the fun-
ction F(x,y)  with respect to x or y on an irregular mesh of quadrilater-
al cells, see also subsection 4.6.1 of the above book.   

:[font = section; inactive; ]
User's Guide
:[font = subsection; inactive; ]
Step 1.
:[font = special4; inactive; nowordwrap; nohscroll; ]

Load and compile the program beginning with the line
:[font = input; nowordwrap; ]
ClearAll[appr2];

:[font = subsection; inactive; ]
Step 2.
:[font = special4; inactive; nowordwrap; nohscroll; ]

Specify the input value kt in the line
:[font = input; startGroup; nowordwrap; ]

              appr2[3]
:[font = print; inactive; formatted; output; endGroup; nowordwrap; ]
No Input Form Generated


;[o]
The difference operator expanded into Taylor
 
  series has the form
                                  2
                           Fxxx xc  x2 yA
(Fx x2 yA - Fxx xc x2 yA + -------------- + 
                                 2
 
         2                2             3
   Fxx x2  yA   Fxxx xc x2  yA   Fxxx x2  yA
   ---------- - -------------- + ----------- - 
       2              2               6
 
                                    2
                             Fxxx xc  x3 yA
   Fx x3 yA + Fxx xc x3 yA - -------------- - 
                                   2
 
         2                2             3
   Fxx x3  yA   Fxxx xc x3  yA   Fxxx x3  yA
   ---------- + -------------- - ----------- + 
       2              2               6
 
                                    2
                             Fxxx xc  x3 yB
   Fx x3 yB - Fxx xc x3 yB + -------------- + 
                                   2
 
         2                2             3
   Fxx x3  yB   Fxxx xc x3  yB   Fxxx x3  yB
   ---------- - -------------- + ----------- - 
       2              2               6
 
                                    2
                             Fxxx xc  x4 yB
   Fx x4 yB + Fxx xc x4 yB - -------------- - 
                                   2
 
         2                2             3
   Fxx x4  yB   Fxxx xc x4  yB   Fxxx x4  yB
   ---------- + -------------- - ----------- - 
       2              2               6
 
   Fxy x2 yA yc + Fxxy xc x2 yA yc - 
 
          2
   Fxxy x2  yA yc
   -------------- + Fxy x3 yA yc - 
         2
 
                             2
                      Fxxy x3  yA yc
   Fxxy xc x3 yA yc + -------------- - 
                            2
 
   Fxy x3 yB yc + Fxxy xc x3 yB yc - 
 
          2
   Fxxy x3  yB yc
   -------------- + Fxy x4 yB yc - 
         2
 
                             2
                      Fxxy x4  yB yc
   Fxxy xc x4 yB yc + -------------- + 
                            2
 
                2                2
   Fxyy x2 yA yc    Fxyy x3 yA yc
   -------------- - -------------- + 
         2                2
 
                2                2
   Fxyy x3 yB yc    Fxyy x4 yB yc
   -------------- - -------------- + Fx x4 yC - 
         2                2
 
                         2               2
                  Fxxx xc  x4 yC   Fxx x4  yC
   Fxx xc x4 yC + -------------- + ---------- - 
                        2              2
 
             2             3
   Fxxx xc x4  yC   Fxxx x4  yC
   -------------- + ----------- - Fx x5 yC + 
         2               6
 
                         2               2
                  Fxxx xc  x5 yC   Fxx x5  yC
   Fxx xc x5 yC - -------------- - ---------- + 
                        2              2
 
             2             3
   Fxxx xc x5  yC   Fxxx x5  yC
   -------------- - ----------- - Fxy x4 yc yC + 
         2               6
 
                             2
                      Fxxy x4  yc yC
   Fxxy xc x4 yc yC - -------------- + 
                            2
 
   Fxy x5 yc yC - Fxxy xc x5 yc yC + 
 
          2                   2
   Fxxy x5  yc yC   Fxyy x4 yc  yC
   -------------- + -------------- - 
         2                2
 
             2
   Fxyy x5 yc  yC
   -------------- - Fx x2 yD + Fxx xc x2 yD - 
         2
 
          2               2                2
   Fxxx xc  x2 yD   Fxx x2  yD   Fxxx xc x2  yD
   -------------- - ---------- + -------------- - 
         2              2              2
 
          3
   Fxxx x2  yD
   ----------- + Fx x5 yD - Fxx xc x5 yD + 
        6
 
          2               2                2
   Fxxx xc  x5 yD   Fxx x5  yD   Fxxx xc x5  yD
   -------------- + ---------- - -------------- + 
         2              2              2
 
          3
   Fxxx x5  yD
   ----------- + Fxy x2 yc yD - Fxxy xc x2 yc yD + 
        6
 
          2
   Fxxy x2  yc yD
   -------------- - Fxy x5 yc yD + 
         2
 
                             2
                      Fxxy x5  yc yD
   Fxxy xc x5 yc yD - -------------- - 
                            2
 
             2                2
   Fxyy x2 yc  yD   Fxyy x5 yc  yD
   -------------- + -------------- + Fy yA y2 - 
         2                2
 
                         2
                  Fxxy xc  yA y2
   Fxy xc yA y2 + -------------- + Fxy x2 yA y2 - 
                        2
 
                             2
                      Fxxy x2  yA y2
   Fxxy xc x2 yA y2 + -------------- - 
                            2
 
   Fyy yA yc y2 + Fxyy xc yA yc y2 - 
 
                                2
                      Fyyy yA yc  y2
   Fxyy x2 yA yc y2 + -------------- - Fy yD y2 + 
                            2
 
                         2
                  Fxxy xc  yD y2
   Fxy xc yD y2 - -------------- - Fxy x2 yD y2 + 
                        2
 
                             2
                      Fxxy x2  yD y2
   Fxxy xc x2 yD y2 - -------------- + 
                            2
 
   Fyy yc yD y2 - Fxyy xc yc yD y2 + 
 
                             2                  2
                      Fyyy yc  yD y2   Fyy yA y2
   Fxyy x2 yc yD y2 - -------------- + ---------- - 
                            2              2
 
                2                2
   Fxyy xc yA y2    Fxyy x2 yA y2
   -------------- + -------------- - 
         2                2
 
                2            2                2
   Fyyy yA yc y2    Fyy yD y2    Fxyy xc yD y2
   -------------- - ---------- + -------------- - 
         2              2              2
 
                2                2             3
   Fxyy x2 yD y2    Fyyy yc yD y2    Fyyy yA y2
   -------------- + -------------- + ----------- - 
         2                2               6
 
             3
   Fyyy yD y2
   ----------- - Fy yA y3 + Fxy xc yA y3 - 
        6
 
          2
   Fxxy xc  yA y3
   -------------- - Fxy x3 yA y3 + 
         2
 
                             2
                      Fxxy x3  yA y3
   Fxxy xc x3 yA y3 - -------------- + Fy yB y3 - 
                            2
 
                         2
                  Fxxy xc  yB y3
   Fxy xc yB y3 + -------------- + Fxy x3 yB y3 - 
                        2
 
                             2
                      Fxxy x3  yB y3
   Fxxy xc x3 yB y3 + -------------- + 
                            2
 
   Fyy yA yc y3 - Fxyy xc yA yc y3 + 
 
   Fxyy x3 yA yc y3 - Fyy yB yc y3 + 
 
   Fxyy xc yB yc y3 - Fxyy x3 yB yc y3 - 
 
             2                2               2
   Fyyy yA yc  y3   Fyyy yB yc  y3   Fyy yA y3
   -------------- + -------------- - ---------- + 
         2                2              2
 
                2                2            2
   Fxyy xc yA y3    Fxyy x3 yA y3    Fyy yB y3
   -------------- - -------------- + ---------- - 
         2                2              2
 
                2                2
   Fxyy xc yB y3    Fxyy x3 yB y3
   -------------- + -------------- + 
         2                2
 
                2                2             3
   Fyyy yA yc y3    Fyyy yB yc y3    Fyyy yA y3
   -------------- - -------------- - ----------- + 
         2                2               6
 
             3
   Fyyy yB y3
   ----------- - Fy yB y4 + Fxy xc yB y4 - 
        6
 
          2
   Fxxy xc  yB y4
   -------------- - Fxy x4 yB y4 + 
         2
 
                             2
                      Fxxy x4  yB y4
   Fxxy xc x4 yB y4 - -------------- + 
                            2
 
   Fyy yB yc y4 - Fxyy xc yB yc y4 + 
 
                                2
                      Fyyy yB yc  y4
   Fxyy x4 yB yc y4 - -------------- + Fy yC y4 - 
                            2
 
                         2
                  Fxxy xc  yC y4
   Fxy xc yC y4 + -------------- + Fxy x4 yC y4 - 
                        2
 
                             2
                      Fxxy x4  yC y4
   Fxxy xc x4 yC y4 + -------------- - 
                            2
 
   Fyy yc yC y4 + Fxyy xc yc yC y4 - 
 
                             2                  2
                      Fyyy yc  yC y4   Fyy yB y4
   Fxyy x4 yc yC y4 + -------------- - ---------- + 
                            2              2
 
                2                2
   Fxyy xc yB y4    Fxyy x4 yB y4
   -------------- - -------------- + 
         2                2
 
                2            2                2
   Fyyy yB yc y4    Fyy yC y4    Fxyy xc yC y4
   -------------- + ---------- - -------------- + 
         2              2              2
 
                2                2             3
   Fxyy x4 yC y4    Fyyy yc yC y4    Fyyy yB y4
   -------------- - -------------- - ----------- + 
         2                2               6
 
             3
   Fyyy yC y4
   ----------- - Fy yC y5 + Fxy xc yC y5 - 
        6
 
          2
   Fxxy xc  yC y5
   -------------- - Fxy x5 yC y5 + 
         2
 
                             2
                      Fxxy x5  yC y5
   Fxxy xc x5 yC y5 - -------------- + 
                            2
 
   Fyy yc yC y5 - Fxyy xc yc yC y5 + 
 
                             2
                      Fyyy yc  yC y5
   Fxyy x5 yc yC y5 - -------------- + Fy yD y5 - 
                            2
 
                         2
                  Fxxy xc  yD y5
   Fxy xc yD y5 + -------------- + Fxy x5 yD y5 - 
                        2
 
                             2
                      Fxxy x5  yD y5
   Fxxy xc x5 yD y5 + -------------- - 
                            2
 
   Fyy yc yD y5 + Fxyy xc yc yD y5 - 
 
                             2                  2
                      Fyyy yc  yD y5   Fyy yC y5
   Fxyy x5 yc yD y5 + -------------- - ---------- + 
                            2              2
 
                2                2
   Fxyy xc yC y5    Fxyy x5 yC y5
   -------------- - -------------- + 
         2                2
 
                2            2                2
   Fyyy yc yC y5    Fyy yD y5    Fxyy xc yD y5
   -------------- + ---------- - -------------- + 
         2              2              2
 
                2                2             3
   Fxyy x5 yD y5    Fyyy yc yD y5    Fyyy yC y5
   -------------- - -------------- - ----------- + 
         2                2               6
 
             3
   Fyyy yD y5
   -----------) / 
        6
 
 (-(xB yA) + xD yA + xA yB - xC yB + xB yC - xD yC - 
 
   xA yD + xC yD)
The coefficient of h^0 in the operator sc2 is
Fx
The coefficient of h^1 in the operator sc2 is
                             2          2
(-3 cax cay cbx Fxx - cay cbx  Fxx + cax  cby Fxx + 
 
   3 cax cbx cby Fxx + cay cbx ccx Fxx - 
 
                              2
   3 cbx cby ccx Fxx - cby ccx  Fxx - 
 
                        2
   cax cbx ccy Fxx + cbx  ccy Fxx + 
 
   3 cbx ccx ccy Fxx + 3 cax cay cdx Fxx - 
 
   cax cby cdx Fxx - cay ccx cdx Fxx + 
 
   cby ccx cdx Fxx + cax ccy cdx Fxx - 
 
                              2              2
   3 ccx ccy cdx Fxx + cay cdx  Fxx - ccy cdx  Fxx - 
 
      2
   cax  cdy Fxx + cax cbx cdy Fxx - 
 
                        2
   cbx ccx cdy Fxx + ccx  cdy Fxx - 
 
   3 cax cdx cdy Fxx + 3 ccx cdx cdy Fxx - 
 
        2
   3 cay  cbx Fxy - cax cay cby Fxy + 
 
                              2
   cay cbx cby Fxy + 3 cax cby  Fxy + 
 
                          2
   cay cby ccx Fxy - 3 cby  ccx Fxy - 
 
   cax cby ccy Fxy - cbx cby ccy Fxy + 
 
                              2
   cby ccx ccy Fxy + 3 cbx ccy  Fxy + 
 
        2
   3 cay  cdx Fxy - cay cby cdx Fxy + 
 
                          2
   cby ccy cdx Fxy - 3 ccy  cdx Fxy + 
 
   cax cay cdy Fxy + cay cbx cdy Fxy - 
 
   cay ccx cdy Fxy + cax ccy cdy Fxy - 
 
   cbx ccy cdy Fxy - ccx ccy cdy Fxy - 
 
   cay cdx cdy Fxy + ccy cdx cdy Fxy - 
 
            2                2
   3 cax cdy  Fxy + 3 ccx cdy  Fxy - 
 
        2                    2
   2 cay  cby Fyy + 2 cay cby  Fyy - 
 
        2                    2
   2 cby  ccy Fyy + 2 cby ccy  Fyy + 
 
        2                2
   2 cay  cdy Fyy - 2 ccy  cdy Fyy - 
 
            2                2
   2 cay cdy  Fyy + 2 ccy cdy  Fyy) / 
 
 (4 (-(cay cbx) + cax cby - cby ccx + cbx ccy + 
 
     cay cdx - ccy cdx - cax cdy + ccx cdy))
The coefficient of h^1 in the operator sc2 is
                                3
 ccy (cax + cbx - 3 ccx - 3 cdx)  Fxxx
(------------------------------------- + 
                  384
 
                                  3
   cby (3 cax + 3 cbx - ccx - cdx)  Fxxx
   ------------------------------------- + 
                    384
 
                                   3
   ccy (-cax + 3 cbx + 3 ccx - cdx)  Fxxx
   -------------------------------------- + 
                    384
 
                                  3
   cby (cax - 3 cbx - 3 ccx + cdx)  Fxxx
   ------------------------------------- + 
                    384
 
                                   3
   cay (-3 cax - 3 cbx + ccx + cdx)  Fxxx
   -------------------------------------- + 
                    384
 
                                  3
   cay (3 cax - cbx - ccx + 3 cdx)  Fxxx
   ------------------------------------- + 
                    384
 
                               3
   (-3 cax + cbx + ccx - 3 cdx)  cdy Fxxx
   -------------------------------------- + 
                    384
 
                               3
   (-cax - cbx + 3 ccx + 3 cdx)  cdy Fxxx
   -------------------------------------- + 
                    384
 
                                    2
   (ccy (-cax - cbx + 3 ccx + 3 cdx)  
 
      (cay + cby - 3 ccy - 3 cdy) Fxxy) / 128 + 
 
                                    2
   (cby (-3 cax - 3 cbx + ccx + cdx)  
 
      (3 cay + 3 cby - ccy - cdy) Fxxy) / 128 + 
 
                                   2
   (ccy (cax - 3 cbx - 3 ccx + cdx)  
 
      (-cay + 3 cby + 3 ccy - cdy) Fxxy) / 128 + 
 
                               2
   ((3 cax - cbx - ccx + 3 cdx)  
 
      (-3 cay + cby + ccy - 3 cdy) cdy Fxxy) / 128 + 
 
                                   2
   (cby (cax - 3 cbx - 3 ccx + cdx)  
 
      (cay - 3 cby - 3 ccy + cdy) Fxxy) / 128 + 
 
                                    2
   (cay (-3 cax - 3 cbx + ccx + cdx)  
 
      (-3 cay - 3 cby + ccy + cdy) Fxxy) / 128 + 
 
                                   2
   (cay (3 cax - cbx - ccx + 3 cdx)  
 
      (3 cay - cby - ccy + 3 cdy) Fxxy) / 128 + 
 
                                2
   ((-cax - cbx + 3 ccx + 3 cdx)  cdy 
 
      (-cay - cby + 3 ccy + 3 cdy) Fxxy) / 128 + 
 
   ((-3 cax + cbx + ccx - 3 cdx) 
 
                                  2
      (-3 cay + cby + ccy - 3 cdy)  cdy Fxyy) / 128 \
 
    + (ccy (-cax + 3 cbx + 3 ccx - cdx) 
 
                                 2
      (cay - 3 cby - 3 ccy + cdy)  Fxyy) / 128 + 
 
   (cby (cax - 3 cbx - 3 ccx + cdx) 
 
                                 2
      (cay - 3 cby - 3 ccy + cdy)  Fxyy) / 128 + 
 
   (cby (3 cax + 3 cbx - ccx - cdx) 
 
                                  2
      (-3 cay - 3 cby + ccy + cdy)  Fxyy) / 128 + 
 
   (cay (-3 cax - 3 cbx + ccx + cdx) 
 
                                  2
      (-3 cay - 3 cby + ccy + cdy)  Fxyy) / 128 + 
 
   (cay (3 cax - cbx - ccx + 3 cdx) 
 
                                 2
      (3 cay - cby - ccy + 3 cdy)  Fxyy) / 128 + 
 
   (ccy (cax + cbx - 3 ccx - 3 cdx) 
 
                                  2
      (-cay - cby + 3 ccy + 3 cdy)  Fxyy) / 128 + 
 
   ((-cax - cbx + 3 ccx + 3 cdx) cdy 
 
                                  2
      (-cay - cby + 3 ccy + 3 cdy)  Fxyy) / 128 + 
 
                                  3
   ccy (cay + cby - 3 ccy - 3 cdy)  Fyyy
   ------------------------------------- + 
                    384
 
                                  3
   cby (3 cay + 3 cby - ccy - cdy)  Fyyy
   ------------------------------------- + 
                    384
 
                                   3
   ccy (-cay + 3 cby + 3 ccy - cdy)  Fyyy
   -------------------------------------- + 
                    384
 
                               3
   (-3 cay + cby + ccy - 3 cdy)  cdy Fyyy
   -------------------------------------- + 
                    384
 
                                  3
   cby (cay - 3 cby - 3 ccy + cdy)  Fyyy
   ------------------------------------- + 
                    384
 
                                   3
   cay (-3 cay - 3 cby + ccy + cdy)  Fyyy
   -------------------------------------- + 
                    384
 
                                  3
   cay (3 cay - cby - ccy + 3 cdy)  Fyyy
   ------------------------------------- + 
                    384
 
                                   3
   cdy (-cay - cby + 3 ccy + 3 cdy)  Fyyy
   --------------------------------------) / 
                    384
 
 (-(cay cbx) + cax cby - cby ccx + cbx ccy + 
 
   cay cdx - ccy cdx - cax cdy + ccx cdy)
The coefficient of h in the operator sc2
in the case of a square grid is
0
The coefficient of h^2 in the operator sc2
in the case of a square grid is
Fxxx
----
 6
:[font = special4; inactive; nowordwrap; nohscroll; ]

Then click in this line and wait for the result of symbolic computation. 
The value of kt  (kt = 2  or  kt = 3)  represents the order of expansion 
 into the Taylor series,

:[font = section; inactive; ]
Program Listing
:[font = input; initialization; nowordwrap; backColorRed = 65280; backColorGreen = 65280; backColorBlue = 65280; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; bold; fontName = "Courier New"; fontSize = 12; ]
*)
ClearAll[appr2];
appr2[kt_]:= 
(
(*  The expansion of the function F(x,y) into the
    Taylor series with respect to (xc, yc) point  *)

    F[x_, y_]:=
(sf = Fc + Fx*(x - xc) + Fy*(y - yc) +
1/2*Fxx*(x - xc)^2 + Fxy*(x - xc)*(y - yc) +
1/2*Fyy*(y - yc)^2;
If[kt > 2, sf = sf +
1/6*Fxxx*(x-xc)^3 + 1/2*Fxxy*(x - xc)^2*(y - yc) +
1/2*Fxyy*(x-xc)*(y-yc)^2+1/6*Fyyy*(y-yc)^3]; sf );

(*  The difference operator under consideration  *)
         dyAB = yB - yA;    dyBC = yC - yB;
         dyCD = yD - yC;    dyDA = yA - yD;
(* -------- The numbering of points:
  1 = (i, j);  2 = (i - 1, j);  3 = (i,j - 1);
  4 = (i + 1,j);  5 = (i,j + 1)  --------------- *)
(*  Substitution of the Taylor series expansions *)
sc1 = (F[x3, y3] + F[x1, y1])*dyAB +
                (F[x1, y1] + F[x4, y4])*dyBC +
                (F[x1, y1] + F[x5, y5])*dyCD +
		(F[x1, y1] + F[x2, y2])*dyDA;
(* ----- Aij is the area of the cell ABCD ------ *)
Aij = ((xA+xB)*dyAB+(xB+xC)*dyBC+(xC+xD)*dyCD +
       (xD + xA)*dyDA)/2;
			  Aij = Simplify[Aij];
  OutputForm[sc1] >> ap2.m;
                        OutputForm[Aij] >>> ap2.m;

       sc1 = sc1;  sc1 = Expand[sc1];
   sc2 = sc1/(2*Aij);
Print["The difference operator expanded into Taylor",
" series has the form"];
			 Print[sc2];

(* -- Representation of the spatial coordinates of 
      points A, B, C, D, 1, 2, 3, 4, 5 as the 
      deviations from the center (xc, yc) of the 
      Taylor expansions ----------------------- *)
       xA = xc + cax*h;   yA = yc + cay*h;
       xB = xc + cbx*h;   yB = yc + cby*h;
       xC = xc + ccx*h;   yC = yc + ccy*h;
       xD = xc + cdx*h;   yD = yc + cdy*h;
                x1 = xc;           y1 = yc;
                x2 = xc + c2x*h;   y2 = yc + c2y*h;
                x3 = xc + c3x*h;   y3 = yc + c3y*h;
                x4 = xc + c4x*h;   y4 = yc + c4y*h;
                x5 = xc + c5x*h;   y5 = yc + c5y*h;
   sc1 = sc1;   sc1 = Expand[sc1];
   OutputForm[sc1] >>> ap2.m;
   Aij = Aij; Aij = Expand[Aij]; Aij= Simplify[Aij];
   OutputForm[Aij] >>> ap2.m;
   a2 = Coefficient[Aij, h, 2];
			 OutputForm[a2] >>> ap2.m;
   r0 = Coefficient[sc1, h, 2];
                         OutputForm[r0] >>> ap2.m; 
   r1 = Coefficient[sc1, h, 3];
                         OutputForm[r1] >>> ap2.m;
   r2 = Coefficient[sc1, h, 4];
                         OutputForm[r2] >>> ap2.m;

(* - The expressions for (x2,y2), (x3,y3), (x4,y4),
   (x5,y5)in terms of (xA,yA), (xB,yB), (xC,yC), 
   (xD,yD)------------------------------------- *)
     c2x = (3*cax + 3*cdx - cbx - ccx)/4;
     c2y = (3*cay + 3*cdy - cby - ccy)/4;
         c3x = (3*cax + 3*cbx - ccx - cdx)/4;
         c3y = (3*cay + 3*cby - ccy - cdy)/4;
             c4x = (3*cbx + 3*ccx - cax - cdx)/4;
             c4y = (3*cby + 3*ccy - cay - cdy)/4;
         c5x = (3*ccx + 3*cdx - cax - cbx)/4;
         c5y = (3*ccy + 3*cdy - cay - cby)/4;
  r0 = r0;  r0 = Simplify[r0];
Print["The coefficient of h^0 in the operator sc2 is"];
       r0 = r0/(2*a2);
Print[r0];
		  OutputForm[r0] >>> ap2.m;
  r1 = r1;  r1 = Simplify[r1];
Print["The coefficient of h^1 in the operator sc2 is"];
       r1 = r1/(2*a2);
Print[r1];
		  OutputForm[r1] >>> ap2.m;
  r2 = r2;  r2 = Simplify[r2];
Print["The coefficient of h^1 in the operator sc2 is"];
       r2 = r2/(2*a2);
Print[r2];
		  OutputForm[r2] >>> ap2.m;

(* ------ The particular case of a square
             grid in the (x,y) plane ----------- *)
 cax = -1/2;  cay = -1/2;  cbx = 1/2;  cby = -1/2;
 ccx = 1/2;   ccy = 1/2;   cdx = -1/2; cdy = 1/2;
 r1 = r1; r1 = Simplify[r1];
Print["The coefficient of h in the operator sc2"];
Print["in the case of a square grid is"];
Print[r1];
           OutputForm[r1] >>> ap2.m;
 r2 = r2; r2 = Simplify[r2];
Print["The coefficient of h^2 in the operator sc2"];
Print["in the case of a square grid is"];
Print[r2];
           OutputForm[r2] >>> ap2.m; )
(*
^*)