(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Arial", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Arial", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Arial", 14, L0, center, nohscroll, bold;
	fontset = section, "Arial", 14, L0, bold, grayBox;
	fontset = subsection, "Arial", 12, L0, bold, blackBox;
	fontset = subsubsection, "Arial", 10, L0, bold, whiteBox;
	fontset = text, "Arial", 12, L0;
	fontset = smalltext, "Arial", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65280;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Arial", 10, L0, nohscroll, italic, B65280;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Arial", 10, L0, nohscroll;
	fontset = clipboard, "Arial", 12, L0, nohscroll;
	fontset = completions, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Arial", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Arial", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = title; inactive; initialization; nohscroll; center; ]
*)
Finite Volume Method
(*
:[font = subtitle; inactive; nohscroll; center; ]

(Local Approximation Study)
:[font = subsubtitle; inactive; nohscroll; center; ]

Triangular Mesh
:[font = name; inactive; nohscroll; ]

                                    Victor G. Ganzha and Evgenii V. Vorozhtsov
:[font = section; inactive; ]
Impressum
:[font = special4; inactive; nowordwrap; nohscroll; ]
This Mathematica-Notebook is part of the book entitled
                                  V.G.Ganzha and E.V.Vorozhtsov
  Numerical Solutions For Partial Differential Equations: Problem Solving
  Using Mathematica.  CRC Press, Boca Raton, Ann Arbor, 1996.

:[font = subsection; inactive; ]
Copyright
:[font = special4; inactive; nowordwrap; nohscroll; ]

 Numerical Solutions For Partial Differential Equations: Problem Solving
 Using Mathematica.  CRC Press, Boca Raton, Ann Arbor, 1996.

:[font = section; inactive; ]
General Description
:[font = special4; inactive; nowordwrap; nohscroll; ]

The program appr3.ma which follows below enables one to compute 
 the symbolic expression for the leading terms of the truncation error  
 of the finite volume approximation of the partial derivative of the fun-
ction F(x,y)  with respect to x or y  on  an irregular or regular mesh of 
triangular cells, see also subsection 4.6.2 of the above book.   

:[font = section; inactive; ]
User's Guide
:[font = subsection; inactive; ]
Step 1.
:[font = special4; inactive; nowordwrap; nohscroll; ]

Load and compile the program beginning with the line
:[font = input; nowordwrap; ]
ClearAll[appr3];

:[font = subsection; inactive; ]
Step 2.
:[font = special4; inactive; nowordwrap; nohscroll; ]

Specify the input value kt in the line
:[font = input; startGroup; nowordwrap; ]

              appr3[3]
:[font = print; inactive; formatted; output; endGroup; nowordwrap; ]
No Input Form Generated


;[o]
Substitution of the Taylor series expansions
The difference operator expanded into Taylor
 
  series has the form
                                     2
                              Fxxx xc  x2 y1
(-(Fx x2 y1) + Fxx xc x2 y1 - -------------- - 
                                    2
 
         2                2             3
   Fxx x2  y1   Fxxx xc x2  y1   Fxxx x2  y1
   ---------- + -------------- - ----------- + 
       2              2               6
 
                                    2
                             Fxxx xc  x6 y1
   Fx x6 y1 - Fxx xc x6 y1 + -------------- + 
                                   2
 
         2                2             3
   Fxx x6  y1   Fxxx xc x6  y1   Fxxx x6  y1
   ---------- - -------------- + ----------- + 
       2              2               6
 
   Fxy x2 yc y1 - Fxxy xc x2 yc y1 + 
 
          2
   Fxxy x2  yc y1
   -------------- - Fxy x6 yc y1 + 
         2
 
                             2
                      Fxxy x6  yc y1
   Fxxy xc x6 yc y1 - -------------- - 
                            2
 
             2                2
   Fxyy x2 yc  y1   Fxyy x6 yc  y1
   -------------- + -------------- + Fx x1 y2 - 
         2                2
 
                         2               2
                  Fxxx xc  x1 y2   Fxx x1  y2
   Fxx xc x1 y2 + -------------- + ---------- - 
                        2              2
 
             2             3
   Fxxx xc x1  y2   Fxxx x1  y2
   -------------- + ----------- - Fx x3 y2 + 
         2               6
 
                         2               2
                  Fxxx xc  x3 y2   Fxx x3  y2
   Fxx xc x3 y2 - -------------- - ---------- + 
                        2              2
 
             2             3
   Fxxx xc x3  y2   Fxxx x3  y2
   -------------- - ----------- - Fxy x1 yc y2 + 
         2               6
 
                             2
                      Fxxy x1  yc y2
   Fxxy xc x1 yc y2 - -------------- + 
                            2
 
   Fxy x3 yc y2 - Fxxy xc x3 yc y2 + 
 
          2                   2
   Fxxy x3  yc y2   Fxyy x1 yc  y2
   -------------- + -------------- - 
         2                2
 
             2
   Fxyy x3 yc  y2
   -------------- + Fxy x1 y1 y2 - 
         2
 
                             2
                      Fxxy x1  y1 y2
   Fxxy xc x1 y1 y2 + -------------- - 
                            2
 
   Fxy x2 y1 y2 + Fxxy xc x2 y1 y2 - 
 
          2
   Fxxy x2  y1 y2
   -------------- - Fxyy x1 yc y1 y2 + 
         2
 
                            2                2
                      Fyy y1  y2   Fxyy xc y1  y2
   Fxyy x2 yc y1 y2 + ---------- - -------------- + 
                          2              2
 
             2                2             3
   Fxyy x1 y1  y2   Fyyy yc y1  y2   Fyyy y1  y2
   -------------- - -------------- + ----------- - 
         2                2               6
 
            2                2                2
   Fyy y1 y2    Fxyy xc y1 y2    Fxyy x2 y1 y2
   ---------- + -------------- - -------------- + 
       2              2                2
 
                2             3
   Fyyy yc y1 y2    Fyyy y1 y2
   -------------- - ----------- + Fx x2 y3 - 
         2               6
 
                         2               2
                  Fxxx xc  x2 y3   Fxx x2  y3
   Fxx xc x2 y3 + -------------- + ---------- - 
                        2              2
 
             2             3
   Fxxx xc x2  y3   Fxxx x2  y3
   -------------- + ----------- - Fx x4 y3 + 
         2               6
 
                         2               2
                  Fxxx xc  x4 y3   Fxx x4  y3
   Fxx xc x4 y3 - -------------- - ---------- + 
                        2              2
 
             2             3
   Fxxx xc x4  y3   Fxxx x4  y3
   -------------- - ----------- - Fxy x2 yc y3 + 
         2               6
 
                             2
                      Fxxy x2  yc y3
   Fxxy xc x2 yc y3 - -------------- + 
                            2
 
   Fxy x4 yc y3 - Fxxy xc x4 yc y3 + 
 
          2                   2
   Fxxy x4  yc y3   Fxyy x2 yc  y3
   -------------- + -------------- - 
         2                2
 
             2
   Fxyy x4 yc  y3
   -------------- + Fxy x2 y2 y3 - 
         2
 
                             2
                      Fxxy x2  y2 y3
   Fxxy xc x2 y2 y3 + -------------- - 
                            2
 
   Fxy x3 y2 y3 + Fxxy xc x3 y2 y3 - 
 
          2
   Fxxy x3  y2 y3
   -------------- - Fxyy x2 yc y2 y3 + 
         2
 
                            2                2
                      Fyy y2  y3   Fxyy xc y2  y3
   Fxyy x3 yc y2 y3 + ---------- - -------------- + 
                          2              2
 
             2                2             3
   Fxyy x2 y2  y3   Fyyy yc y2  y3   Fyyy y2  y3
   -------------- - -------------- + ----------- - 
         2                2               6
 
            2                2                2
   Fyy y2 y3    Fxyy xc y2 y3    Fxyy x3 y2 y3
   ---------- + -------------- - -------------- + 
       2              2                2
 
                2             3
   Fyyy yc y2 y3    Fyyy y2 y3
   -------------- - ----------- + Fx x3 y4 - 
         2               6
 
                         2               2
                  Fxxx xc  x3 y4   Fxx x3  y4
   Fxx xc x3 y4 + -------------- + ---------- - 
                        2              2
 
             2             3
   Fxxx xc x3  y4   Fxxx x3  y4
   -------------- + ----------- - Fx x5 y4 + 
         2               6
 
                         2               2
                  Fxxx xc  x5 y4   Fxx x5  y4
   Fxx xc x5 y4 - -------------- - ---------- + 
                        2              2
 
             2             3
   Fxxx xc x5  y4   Fxxx x5  y4
   -------------- - ----------- - Fxy x3 yc y4 + 
         2               6
 
                             2
                      Fxxy x3  yc y4
   Fxxy xc x3 yc y4 - -------------- + 
                            2
 
   Fxy x5 yc y4 - Fxxy xc x5 yc y4 + 
 
          2                   2
   Fxxy x5  yc y4   Fxyy x3 yc  y4
   -------------- + -------------- - 
         2                2
 
             2
   Fxyy x5 yc  y4
   -------------- + Fxy x3 y3 y4 - 
         2
 
                             2
                      Fxxy x3  y3 y4
   Fxxy xc x3 y3 y4 + -------------- - 
                            2
 
   Fxy x4 y3 y4 + Fxxy xc x4 y3 y4 - 
 
          2
   Fxxy x4  y3 y4
   -------------- - Fxyy x3 yc y3 y4 + 
         2
 
                            2                2
                      Fyy y3  y4   Fxyy xc y3  y4
   Fxyy x4 yc y3 y4 + ---------- - -------------- + 
                          2              2
 
             2                2             3
   Fxyy x3 y3  y4   Fyyy yc y3  y4   Fyyy y3  y4
   -------------- - -------------- + ----------- - 
         2                2               6
 
            2                2                2
   Fyy y3 y4    Fxyy xc y3 y4    Fxyy x4 y3 y4
   ---------- + -------------- - -------------- + 
       2              2                2
 
                2             3
   Fyyy yc y3 y4    Fyyy y3 y4
   -------------- - ----------- + Fx x4 y5 - 
         2               6
 
                         2               2
                  Fxxx xc  x4 y5   Fxx x4  y5
   Fxx xc x4 y5 + -------------- + ---------- - 
                        2              2
 
             2             3
   Fxxx xc x4  y5   Fxxx x4  y5
   -------------- + ----------- - Fx x6 y5 + 
         2               6
 
                         2               2
                  Fxxx xc  x6 y5   Fxx x6  y5
   Fxx xc x6 y5 - -------------- - ---------- + 
                        2              2
 
             2             3
   Fxxx xc x6  y5   Fxxx x6  y5
   -------------- - ----------- - Fxy x4 yc y5 + 
         2               6
 
                             2
                      Fxxy x4  yc y5
   Fxxy xc x4 yc y5 - -------------- + 
                            2
 
   Fxy x6 yc y5 - Fxxy xc x6 yc y5 + 
 
          2                   2
   Fxxy x6  yc y5   Fxyy x4 yc  y5
   -------------- + -------------- - 
         2                2
 
             2
   Fxyy x6 yc  y5
   -------------- + Fxy x4 y4 y5 - 
         2
 
                             2
                      Fxxy x4  y4 y5
   Fxxy xc x4 y4 y5 + -------------- - 
                            2
 
   Fxy x5 y4 y5 + Fxxy xc x5 y4 y5 - 
 
          2
   Fxxy x5  y4 y5
   -------------- - Fxyy x4 yc y4 y5 + 
         2
 
                            2                2
                      Fyy y4  y5   Fxyy xc y4  y5
   Fxyy x5 yc y4 y5 + ---------- - -------------- + 
                          2              2
 
             2                2             3
   Fxyy x4 y4  y5   Fyyy yc y4  y5   Fyyy y4  y5
   -------------- - -------------- + ----------- - 
         2                2               6
 
            2                2                2
   Fyy y4 y5    Fxyy xc y4 y5    Fxyy x5 y4 y5
   ---------- + -------------- - -------------- + 
       2              2                2
 
                2             3
   Fyyy yc y4 y5    Fyyy y4 y5
   -------------- - ----------- - Fx x1 y6 + 
         2               6
 
                         2               2
                  Fxxx xc  x1 y6   Fxx x1  y6
   Fxx xc x1 y6 - -------------- - ---------- + 
                        2              2
 
             2             3
   Fxxx xc x1  y6   Fxxx x1  y6
   -------------- - ----------- + Fx x5 y6 - 
         2               6
 
                         2               2
                  Fxxx xc  x5 y6   Fxx x5  y6
   Fxx xc x5 y6 + -------------- + ---------- - 
                        2              2
 
             2             3
   Fxxx xc x5  y6   Fxxx x5  y6
   -------------- + ----------- + Fxy x1 yc y6 - 
         2               6
 
                             2
                      Fxxy x1  yc y6
   Fxxy xc x1 yc y6 + -------------- - 
                            2
 
   Fxy x5 yc y6 + Fxxy xc x5 yc y6 - 
 
          2                   2
   Fxxy x5  yc y6   Fxyy x1 yc  y6
   -------------- - -------------- + 
         2                2
 
             2
   Fxyy x5 yc  y6
   -------------- - Fxy x1 y1 y6 + 
         2
 
                             2
                      Fxxy x1  y1 y6
   Fxxy xc x1 y1 y6 - -------------- + 
                            2
 
   Fxy x6 y1 y6 - Fxxy xc x6 y1 y6 + 
 
          2
   Fxxy x6  y1 y6
   -------------- + Fxyy x1 yc y1 y6 - 
         2
 
                            2                2
                      Fyy y1  y6   Fxyy xc y1  y6
   Fxyy x6 yc y1 y6 - ---------- + -------------- - 
                          2              2
 
             2                2             3
   Fxyy x1 y1  y6   Fyyy yc y1  y6   Fyyy y1  y6
   -------------- + -------------- - ----------- + 
         2                2               6
 
   Fxy x5 y5 y6 - Fxxy xc x5 y5 y6 + 
 
          2
   Fxxy x5  y5 y6
   -------------- - Fxy x6 y5 y6 + 
         2
 
                             2
                      Fxxy x6  y5 y6
   Fxxy xc x6 y5 y6 - -------------- - 
                            2
 
   Fxyy x5 yc y5 y6 + Fxyy x6 yc y5 y6 + 
 
         2                2                2
   Fyy y5  y6   Fxyy xc y5  y6   Fxyy x5 y5  y6
   ---------- - -------------- + -------------- - 
       2              2                2
 
             2             3               2
   Fyyy yc y5  y6   Fyyy y5  y6   Fyy y1 y6
   -------------- + ----------- + ---------- - 
         2               6            2
 
                2                2
   Fxyy xc y1 y6    Fxyy x6 y1 y6
   -------------- + -------------- - 
         2                2
 
                2            2                2
   Fyyy yc y1 y6    Fyy y5 y6    Fxyy xc y5 y6
   -------------- - ---------- + -------------- - 
         2              2              2
 
                2                2             3
   Fxyy x6 y5 y6    Fyyy yc y5 y6    Fyyy y1 y6
   -------------- + -------------- + ----------- - 
         2                2               6
 
             3
   Fyyy y5 y6
   -----------) / 
        6
 
 (-(x2 y1) + x6 y1 + x1 y2 - x3 y2 + x2 y3 - x4 y3 + 
 
   x3 y4 - x5 y4 + x4 y5 - x6 y5 - x1 y6 + x5 y6)
Substitution of the coordinates of points 1,...,6
into the expanded difference operator as the
deviations from the (xc, yc) point.
Determination of the coefficient of h^2 in the
numerator of the expanded difference operator.
Determination of the coefficient of h^3 in the
numerator of the expanded difference operator.
Determination of the coefficient of h^4 in the
numerator of the expanded difference operator.
The coefficient of h^0 in the operator sc2 is
Fx
The coefficient of h^1 in the operator sc2 is
          2           2                  2
(-(c1y c2x  Fxx) + c1x  c2y Fxx - c2y c3x  Fxx + 
 
      2                  2          2
   c2x  c3y Fxx - c3y c4x  Fxx + c3x  c4y Fxx - 
 
          2          2                  2
   c4y c5x  Fxx + c4x  c5y Fxx + c1y c6x  Fxx - 
 
          2          2              2
   c5y c6x  Fxx - c1x  c6y Fxx + c5x  c6y Fxx + 
 
   2 c1x c1y c2y Fxy - 2 c1y c2x c2y Fxy + 
 
   2 c2x c2y c3y Fxy - 2 c2y c3x c3y Fxy + 
 
   2 c3x c3y c4y Fxy - 2 c3y c4x c4y Fxy + 
 
   2 c4x c4y c5y Fxy - 2 c4y c5x c5y Fxy - 
 
   2 c1x c1y c6y Fxy + 2 c5x c5y c6y Fxy + 
 
   2 c1y c6x c6y Fxy - 2 c5y c6x c6y Fxy + 
 
      2                  2          2
   c1y  c2y Fyy - c1y c2y  Fyy + c2y  c3y Fyy - 
 
          2          2                  2
   c2y c3y  Fyy + c3y  c4y Fyy - c3y c4y  Fyy + 
 
      2                  2          2
   c4y  c5y Fyy - c4y c5y  Fyy - c1y  c6y Fyy + 
 
      2                  2              2
   c5y  c6y Fyy + c1y c6y  Fyy - c5y c6y  Fyy) / 
 
 (2 (-(c1y c2x) + c1x c2y - c2y c3x + c2x c3y - 
 
     c3y c4x + c3x c4y - c4y c5x + c4x c5y + 
 
     c1y c6x - c5y c6x - c1x c6y + c5x c6y))
The coefficient of h^2 in the operator sc2 is
          3            3                   3
(-(c1y c2x  Fxxx) + c1x  c2y Fxxx - c2y c3x  Fxxx + 
 
      3                   3           3
   c2x  c3y Fxxx - c3y c4x  Fxxx + c3x  c4y Fxxx - 
 
          3           3                   3
   c4y c5x  Fxxx + c4x  c5y Fxxx + c1y c6x  Fxxx - 
 
          3           3               3
   c5y c6x  Fxxx - c1x  c6y Fxxx + c5x  c6y Fxxx + 
 
        2                         2
   3 c1x  c1y c2y Fxxy - 3 c1y c2x  c2y Fxxy + 
 
        2                         2
   3 c2x  c2y c3y Fxxy - 3 c2y c3x  c3y Fxxy + 
 
        2                         2
   3 c3x  c3y c4y Fxxy - 3 c3y c4x  c4y Fxxy + 
 
        2                         2
   3 c4x  c4y c5y Fxxy - 3 c4y c5x  c5y Fxxy - 
 
        2                     2
   3 c1x  c1y c6y Fxxy + 3 c5x  c5y c6y Fxxy + 
 
            2                     2
   3 c1y c6x  c6y Fxxy - 3 c5y c6x  c6y Fxxy + 
 
            2                         2
   3 c1x c1y  c2y Fxyy - 3 c1y c2x c2y  Fxyy + 
 
            2                         2
   3 c2x c2y  c3y Fxyy - 3 c2y c3x c3y  Fxyy + 
 
            2                         2
   3 c3x c3y  c4y Fxyy - 3 c3y c4x c4y  Fxyy + 
 
            2                         2
   3 c4x c4y  c5y Fxyy - 3 c4y c5x c5y  Fxyy - 
 
            2                     2
   3 c1x c1y  c6y Fxyy + 3 c5x c5y  c6y Fxyy + 
 
                2                     2
   3 c1y c6x c6y  Fxyy - 3 c5y c6x c6y  Fxyy + 
 
      3                   3           3
   c1y  c2y Fyyy - c1y c2y  Fyyy + c2y  c3y Fyyy - 
 
          3           3                   3
   c2y c3y  Fyyy + c3y  c4y Fyyy - c3y c4y  Fyyy + 
 
      3                   3           3
   c4y  c5y Fyyy - c4y c5y  Fyyy - c1y  c6y Fyyy + 
 
      3                   3               3
   c5y  c6y Fyyy + c1y c6y  Fyyy - c5y c6y  Fyyy) / 
 
 (6 (-(c1y c2x) + c1x c2y - c2y c3x + c2x c3y - 
 
     c3y c4x + c3x c4y - c4y c5x + c4x c5y + 
 
     c1y c6x - c5y c6x - c1x c6y + c5x c6y))
The particular case of equilateral triangles
{0.5, 1., 0.5, -0.5, -1., -0.5}
{-0.86602540378443864676, 0, 0.86602540378443864676, 
 
 0.86602540378443864676, 0, -0.86602540378443864676}
The coefficient of h in the operator sc2
in the case of equilateral triangular cells is
0
The coefficient of h^2 in the operator sc2
in the case of equilateral triangular cells is
0.125 Fxxx + 0.125 Fxyy
:[font = special4; inactive; nowordwrap; nohscroll; ]

Then click in this line and wait for the result of symbolic computation. 
The value of kt  (kt = 2  or  kt = 3)  represents the order of expansion 
 into the Taylor series,

:[font = section; inactive; ]
Program Listing
:[font = input; nowordwrap; ]

ClearAll[appr3];
appr3[kt_]:=
(
(*  The expansion of the function F(x,y) into the
    Taylor series with respect to (xc, yc) point *)

    F[x_, y_]:=
(sf = Fc + Fx*(x - xc) + Fy*(y - yc) +
1/2*Fxx*(x - xc)^2 + Fxy*(x - xc)*(y - yc) +
1/2*Fyy*(y - yc)^2;
If[kt > 2, sf = sf +
1/6*Fxxx*(x-xc)^3 + 1/2*Fxxy*(x - xc)^2*(y - yc) +
1/2*Fxyy*(x-xc)*(y-yc)^2+1/6*Fyyy*(y-yc)^3]; sf );

(*  The difference operator under consideration  *)
         dy12 = y2 - y1;    dy23 = y3 - y2;
         dy34 = y4 - y3;    dy45 = y5 - y4;
         dy56 = y6 - y5;    dy67 = y1 - y6;
(* Substitution of the Taylor series expansions  *)
Print["Substitution of the Taylor series expansions"];
sc1 = (F[x1, y1] + F[x2, y2])*dy12 +
                  (F[x2, y2] + F[x3, y3])*dy23 +
                  (F[x3, y3] + F[x4, y4])*dy34 +
		  (F[x4, y4] + F[x5, y5])*dy45 +
                  (F[x5, y5] + F[x6, y6])*dy56 +
		  (F[x6, y6] + F[x1, y1])*dy67;
(* ------ Ai is the area of the hexagon -------- *)
Ai = ((x1+x2)*dy12+(x2+x3)*dy23 + (x3 + x4)*dy34 +
     (x4+x5)*dy45+(x5+x6)*dy56 + (x6 + x1)*dy67)/2;
			  Ai = Simplify[Ai];
  OutputForm[sc1] >> ap3.m;
                         OutputForm[Ai] >>> ap3.m;
                sc1 = sc1;  sc1 = Expand[sc1];
   sc2 = sc1/(2*Ai);
Print["The difference operator expanded into Taylor",
" series has the form"];
			 Print[sc2];

(* -- Representation of the spatial coordinates of 
      points 1, 2, 3, 4, 5, 6 as the deviations 
      from the center (xc, yc) of the Taylor 
      expansions ------------------------------ *)
         x1 = xc + c1x*h;   y1 = yc + c1y*h;
         x2 = xc + c2x*h;   y2 = yc + c2y*h;
         x3 = xc + c3x*h;   y3 = yc + c3y*h;
         x4 = xc + c4x*h;   y4 = yc + c4y*h;
         x5 = xc + c5x*h;   y5 = yc + c5y*h;
         x6 = xc + c6x*h;   y6 = yc + c6y*h;
Print["Substitution of the coordinates of points 1,...,6"];
Print["into the expanded difference operator as the"];
Print["deviations from the (xc, yc) point."];
   sc1 = sc1;   sc1 = Expand[sc1];
   OutputForm[sc1] >>> ap3.m;
   Ai = Ai;   Ai = Expand[Ai];  Ai = Simplify[Ai];
   OutputForm[Ai] >>> ap3.m;
   a2 = Coefficient[Ai, h, 2];
			OutputForm[a2] >>> ap3.m;
Print["Determination of the coefficient of h^2 in the"];
Print["numerator of the expanded difference operator."];
   r0 = Coefficient[sc1, h, 2];  r0 = Simplify[r0];
                          OutputForm[r0] >>> ap3.m;
Print["Determination of the coefficient of h^3 in the"];
Print["numerator of the expanded difference operator."];
   r1 = Coefficient[sc1, h, 3];  r1 = Simplify[r1];
            OutputForm[r1] >>> ap3.m;

Print["Determination of the coefficient of h^4 in the"];
Print["numerator of the expanded difference operator."];
   r2 = Coefficient[sc1, h, 4];  r2 = Simplify[r2];
              OutputForm[r2] >>> ap3.m;

Print["The coefficient of h^0 in the operator sc2 is"];
       r0 = r0/(2*a2);
Print[r0];
	    OutputForm[r0] >>> ap3.m;
Print["The coefficient of h^1 in the operator sc2 is"];
       r1 = r1/(2*a2);
                          Print[r1];
OutputForm[r1] >>> ap3.m;
Print["The coefficient of h^2 in the operator sc2 is"];
            r2 = r2/(2*a2);
Print[r2];
		  OutputForm[r2] >>> ap3.m;

(* -------- The particular case of equilateral
               triangular cells ---------------- *)
Print["The particular case of equilateral triangles"];
 cc = Table[N[Cos[(4 + j)*Pi/3], 20], {j, 6}];
 ss = Table[N[Sin[(4 + j)*Pi/3], 20], {j, 6}];
        Print[cc];         Print[ss];
c1x=cc[[1]]; c1y=ss[[1]]; c2x=cc[[2]]; c2y=ss[[2]];
c3x=cc[[3]]; c3y=ss[[3]]; c4x=cc[[4]]; c4y=ss[[4]];
c5x=cc[[5]]; c5y=ss[[5]]; c6x=cc[[6]]; c6y=ss[[6]];
 r1 = r1; r1 = Simplify[r1];
Print["The coefficient of h in the operator sc2"];
Print["in the case of equilateral triangular cells is"];
Print[r1];
                 OutputForm[r1] >>> ap3.m;
 r2 = r2; r2 = Simplify[r2];
Print["The coefficient of h^2 in the operator sc2"];
Print["in the case of equilateral triangular cells is"];
Print[r2];
           OutputForm[r2] >>> ap3.m; )
^*)