(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Arial", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Arial", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Arial", 14, L0, center, nohscroll, bold;
	fontset = section, "Arial", 14, L0, bold, grayBox;
	fontset = subsection, "Arial", 12, L0, bold, blackBox;
	fontset = subsubsection, "Arial", 10, L0, bold, whiteBox;
	fontset = text, "Arial", 12, L0;
	fontset = smalltext, "Arial", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65280;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Arial", 10, L0, nohscroll, italic, B65280;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Arial", 10, L0, nohscroll;
	fontset = clipboard, "Arial", 12, L0, nohscroll;
	fontset = completions, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Arial", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Arial", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = title; inactive; initialization; nohscroll; center; ]
*)
Logically Rectangular Grid
(*
:[font = subtitle; inactive; nohscroll; center; ]

(Local Approximation Study)
:[font = name; inactive; nohscroll; ]

                                    Victor G. Ganzha and Evgenii V. Vorozhtsov
:[font = section; inactive; ]
Impressum
:[font = special4; inactive; nowordwrap; nohscroll; ]
This Mathematica-Notebook is part of the book entitled
                                  V.G.Ganzha and E.V.Vorozhtsov
  Numerical Solutions For Partial Differential Equations: Problem Solving
  Using Mathematica.  CRC Press, Boca Raton, Ann Arbor, 1996.

:[font = subsection; inactive; ]
Copyright
:[font = special4; inactive; nowordwrap; nohscroll; ]

 Numerical Solutions For Partial Differential Equations: Problem Solving
 Using Mathematica.  CRC Press, Boca Raton, Ann Arbor, 1996.

:[font = section; inactive; ]
General Description
:[font = special4; inactive; nowordwrap; nohscroll; ]

The program appr4.ma which follows below enables one to compute 
 the symbolic expression for the leading terms of the truncation error  
 of  the  finite difference approximation of the partial derivative of the 
 function F(x,y)  with respect to x or y on a curvilinear logically rectang-
 ular grid, see also subsection 4.7.1 of the above book.   

:[font = section; inactive; ]
User's Guide
:[font = subsection; inactive; ]
Step 1.
:[font = special4; inactive; nowordwrap; nohscroll; ]

Load and compile the program beginning with the line
:[font = input; nowordwrap; ]
ClearAll[appr4];

:[font = subsection; inactive; ]
Step 2.
:[font = special4; inactive; nowordwrap; nohscroll; ]

Specify the input value kt in the line
:[font = input; startGroup; nowordwrap; ]

              appr4[3]
:[font = print; inactive; formatted; output; endGroup; nowordwrap; ]
No Input Form Generated


;[o]
Substitution of the Taylor series expansions
The difference operator expanded into Taylor
 
  series has the form
                                        2
    -(fx x3 y1)   fxx xc x3 y1   fxxx xc  x3 y1
(4 (----------- + ------------ - -------------- - 
         4             4               8
 
           2                2             3
     fxx x3  y1   fxxx xc x3  y1   fxxx x3  y1
     ---------- + -------------- - ----------- + 
         8              8              24
 
                                      2
     fx x4 y1   fxx xc x4 y1   fxxx xc  x4 y1
     -------- - ------------ + -------------- + 
        4            4               8
 
           2                2             3
     fxx x4  y1   fxxx xc x4  y1   fxxx x4  y1
     ---------- - -------------- + ----------- + 
         8              8              24
 
     fxy x3 yc y1   fxxy xc x3 yc y1
     ------------ - ---------------- + 
          4                4
 
            2
     fxxy x3  yc y1   fxy x4 yc y1
     -------------- - ------------ + 
           8               4
 
                               2
     fxxy xc x4 yc y1   fxxy x4  yc y1
     ---------------- - -------------- - 
            4                 8
 
               2                2
     fxyy x3 yc  y1   fxyy x4 yc  y1   fx x3 y2
     -------------- + -------------- + -------- - 
           8                8             4
 
                           2               2
     fxx xc x3 y2   fxxx xc  x3 y2   fxx x3  y2
     ------------ + -------------- + ---------- - 
          4               8              8
 
               2             3
     fxxx xc x3  y2   fxxx x3  y2   fx x4 y2
     -------------- + ----------- - -------- + 
           8              24           4
 
                           2               2
     fxx xc x4 y2   fxxx xc  x4 y2   fxx x4  y2
     ------------ - -------------- - ---------- + 
          4               8              8
 
               2             3
     fxxx xc x4  y2   fxxx x4  y2   fxy x3 yc y2
     -------------- - ----------- - ------------ + 
           8              24             4
 
                               2
     fxxy xc x3 yc y2   fxxy x3  yc y2
     ---------------- - -------------- + 
            4                 8
 
     fxy x4 yc y2   fxxy xc x4 yc y2
     ------------ - ---------------- + 
          4                4
 
            2                   2
     fxxy x4  yc y2   fxyy x3 yc  y2
     -------------- + -------------- - 
           8                8
 
               2
     fxyy x4 yc  y2   fx x1 y3   fxx xc x1 y3
     -------------- + -------- - ------------ + 
           8             4            4
 
            2               2                2
     fxxx xc  x1 y3   fxx x1  y3   fxxx xc x1  y3
     -------------- + ---------- - -------------- + 
           8              8              8
 
            3
     fxxx x1  y3   fx x2 y3   fxx xc x2 y3
     ----------- - -------- + ------------ - 
         24           4            4
 
            2               2                2
     fxxx xc  x2 y3   fxx x2  y3   fxxx xc x2  y3
     -------------- - ---------- + -------------- - 
           8              8              8
 
            3
     fxxx x2  y3   fxy x1 yc y3   fxxy xc x1 yc y3
     ----------- - ------------ + ---------------- - 
         24             4                4
 
            2
     fxxy x1  yc y3   fxy x2 yc y3
     -------------- + ------------ - 
           8               4
 
                               2
     fxxy xc x2 yc y3   fxxy x2  yc y3
     ---------------- + -------------- + 
            4                 8
 
               2                2
     fxyy x1 yc  y3   fxyy x2 yc  y3
     -------------- - -------------- + 
           8                8
 
     fxy x1 y1 y3   fxxy xc x1 y1 y3
     ------------ - ---------------- + 
          4                4
 
            2
     fxxy x1  y1 y3   fxy x3 y1 y3
     -------------- - ------------ + 
           8               4
 
                               2
     fxxy xc x3 y1 y3   fxxy x3  y1 y3
     ---------------- - -------------- - 
            4                 8
 
     fxyy x1 yc y1 y3   fxyy x3 yc y1 y3
     ---------------- + ---------------- + 
            4                  4
 
           2                2                2
     fyy y1  y3   fxyy xc y1  y3   fxyy x1 y1  y3
     ---------- - -------------- + -------------- - 
         8              8                8
 
               2             3
     fyyy yc y1  y3   fyyy y1  y3   fxy x2 y2 y3
     -------------- + ----------- - ------------ + 
           8              24             4
 
                               2
     fxxy xc x2 y2 y3   fxxy x2  y2 y3
     ---------------- - -------------- + 
            4                 8
 
     fxy x3 y2 y3   fxxy xc x3 y2 y3
     ------------ - ---------------- + 
          4                4
 
            2
     fxxy x3  y2 y3   fxyy x2 yc y2 y3
     -------------- + ---------------- - 
           8                 4
 
                              2
     fxyy x3 yc y2 y3   fyy y2  y3
     ---------------- - ---------- + 
            4               8
 
               2                2
     fxyy xc y2  y3   fxyy x2 y2  y3
     -------------- - -------------- + 
           8                8
 
               2             3               2
     fyyy yc y2  y3   fyyy y2  y3   fyy y1 y3
     -------------- - ----------- - ---------- + 
           8              24            8
 
                  2                2
     fxyy xc y1 y3    fxyy x3 y1 y3
     -------------- - -------------- + 
           8                8
 
                  2            2                2
     fyyy yc y1 y3    fyy y2 y3    fxyy xc y2 y3
     -------------- + ---------- - -------------- + 
           8              8              8
 
                  2                2             3
     fxyy x3 y2 y3    fyyy yc y2 y3    fyyy y1 y3
     -------------- - -------------- - ----------- + 
           8                8              24
 
               3
     fyyy y2 y3    fx x1 y4   fxx xc x1 y4
     ----------- - -------- + ------------ - 
         24           4            4
 
            2               2                2
     fxxx xc  x1 y4   fxx x1  y4   fxxx xc x1  y4
     -------------- - ---------- + -------------- - 
           8              8              8
 
            3
     fxxx x1  y4   fx x2 y4   fxx xc x2 y4
     ----------- + -------- - ------------ + 
         24           4            4
 
            2               2                2
     fxxx xc  x2 y4   fxx x2  y4   fxxx xc x2  y4
     -------------- + ---------- - -------------- + 
           8              8              8
 
            3
     fxxx x2  y4   fxy x1 yc y4   fxxy xc x1 yc y4
     ----------- + ------------ - ---------------- + 
         24             4                4
 
            2
     fxxy x1  yc y4   fxy x2 yc y4
     -------------- - ------------ + 
           8               4
 
                               2
     fxxy xc x2 yc y4   fxxy x2  yc y4
     ---------------- - -------------- - 
            4                 8
 
               2                2
     fxyy x1 yc  y4   fxyy x2 yc  y4
     -------------- + -------------- - 
           8                8
 
     fxy x1 y1 y4   fxxy xc x1 y1 y4
     ------------ + ---------------- - 
          4                4
 
            2
     fxxy x1  y1 y4   fxy x4 y1 y4
     -------------- + ------------ - 
           8               4
 
                               2
     fxxy xc x4 y1 y4   fxxy x4  y1 y4
     ---------------- + -------------- + 
            4                 8
 
     fxyy x1 yc y1 y4   fxyy x4 yc y1 y4
     ---------------- - ---------------- - 
            4                  4
 
           2                2                2
     fyy y1  y4   fxyy xc y1  y4   fxyy x1 y1  y4
     ---------- + -------------- - -------------- + 
         8              8                8
 
               2             3
     fyyy yc y1  y4   fyyy y1  y4   fxy x2 y2 y4
     -------------- - ----------- + ------------ - 
           8              24             4
 
                               2
     fxxy xc x2 y2 y4   fxxy x2  y2 y4
     ---------------- + -------------- - 
            4                 8
 
     fxy x4 y2 y4   fxxy xc x4 y2 y4
     ------------ + ---------------- - 
          4                4
 
            2
     fxxy x4  y2 y4   fxyy x2 yc y2 y4
     -------------- - ---------------- + 
           8                 4
 
                              2
     fxyy x4 yc y2 y4   fyy y2  y4
     ---------------- + ---------- - 
            4               8
 
               2                2
     fxyy xc y2  y4   fxyy x2 y2  y4
     -------------- + -------------- - 
           8                8
 
               2             3               2
     fyyy yc y2  y4   fyyy y2  y4   fyy y1 y4
     -------------- + ----------- + ---------- - 
           8              24            8
 
                  2                2
     fxyy xc y1 y4    fxyy x4 y1 y4
     -------------- + -------------- - 
           8                8
 
                  2            2                2
     fyyy yc y1 y4    fyy y2 y4    fxyy xc y2 y4
     -------------- - ---------- + -------------- - 
           8              8              8
 
                  2                2             3
     fxyy x4 y2 y4    fyyy yc y2 y4    fyyy y1 y4
     -------------- + -------------- + ----------- - 
           8                8              24
 
               3
     fyyy y2 y4
     -----------)) / 
         24
 
 (-(x3 y1) + x4 y1 + x3 y2 - x4 y2 + x1 y3 - x2 y3 - 
 
   x1 y4 + x2 y4)
Substitution of the coordinates of points 1,...,4
into the expanded difference operator as the
deviations from the (xc, yc) point.
Determination of the coefficient of h^2 in the
numerator of the expanded difference operator.
Determination of the coefficient of h^3 in the
numerator of the expanded difference operator.
Determination of the coefficient of h^4 in the
numerator of the expanded difference operator.
The coefficient of h^0 in the operator Dxhf is
fx
The coefficient of h^1 in the operator Dxhf is
          2               2          2
(-(c1y c3x  fxx) + c2y c3x  fxx + c1x  c3y fxx - 
 
      2                  2              2
   c2x  c3y fxx + c1y c4x  fxx - c2y c4x  fxx - 
 
      2              2
   c1x  c4y fxx + c2x  c4y fxx + 2 c1x c1y c3y fxy - 
 
   2 c2x c2y c3y fxy - 2 c1y c3x c3y fxy + 
 
   2 c2y c3x c3y fxy - 2 c1x c1y c4y fxy + 
 
   2 c2x c2y c4y fxy + 2 c1y c4x c4y fxy - 
 
                          2              2
   2 c2y c4x c4y fxy + c1y  c3y fyy - c2y  c3y fyy - 
 
          2              2          2
   c1y c3y  fyy + c2y c3y  fyy - c1y  c4y fyy + 
 
      2                  2              2
   c2y  c4y fyy + c1y c4y  fyy - c2y c4y  fyy) / 
 
 (2 (-(c1y c3x) + c2y c3x + c1x c3y - c2x c3y + 
 
     c1y c4x - c2y c4x - c1x c4y + c2x c4y))
The coefficient of h^2 in the operator Dxhf is
          3                3           3
(-(c1y c3x  fxxx) + c2y c3x  fxxx + c1x  c3y fxxx - 
 
      3                   3               3
   c2x  c3y fxxx + c1y c4x  fxxx - c2y c4x  fxxx - 
 
      3               3
   c1x  c4y fxxx + c2x  c4y fxxx + 
 
        2                     2
   3 c1x  c1y c3y fxxy - 3 c2x  c2y c3y fxxy - 
 
            2                     2
   3 c1y c3x  c3y fxxy + 3 c2y c3x  c3y fxxy - 
 
        2                     2
   3 c1x  c1y c4y fxxy + 3 c2x  c2y c4y fxxy + 
 
            2                     2
   3 c1y c4x  c4y fxxy - 3 c2y c4x  c4y fxxy + 
 
            2                     2
   3 c1x c1y  c3y fxyy - 3 c2x c2y  c3y fxyy - 
 
                2                     2
   3 c1y c3x c3y  fxyy + 3 c2y c3x c3y  fxyy - 
 
            2                     2
   3 c1x c1y  c4y fxyy + 3 c2x c2y  c4y fxyy + 
 
                2                     2
   3 c1y c4x c4y  fxyy - 3 c2y c4x c4y  fxyy + 
 
      3               3                   3
   c1y  c3y fyyy - c2y  c3y fyyy - c1y c3y  fyyy + 
 
          3           3               3
   c2y c3y  fyyy - c1y  c4y fyyy + c2y  c4y fyyy + 
 
          3               3
   c1y c4y  fyyy - c2y c4y  fyyy) / 
 
 (6 (-(c1y c3x) + c2y c3x + c1x c3y - c2x c3y + 
 
     c1y c4x - c2y c4x - c1x c4y + c2x c4y))
The particular case of square cells
The coefficient of h in the operator Dxhf
in the case of square cells is
0
The coefficient of h^2 in the operator Dxhf
in the case of square cells is
fxxx
----
 6
:[font = special4; inactive; nowordwrap; nohscroll; ]

Then click in this line and wait for the result of symbolic computation. 
The value of kt  (kt = 2  or  kt = 3)  represents the order of expansion 
 into the Taylor series,

:[font = section; inactive; ]
Program Listing
:[font = input; initialization; nowordwrap; backColorRed = 65280; backColorGreen = 65280; backColorBlue = 65280; fontColorRed = 0; fontColorGreen = 0; fontColorBlue = 0; bold; fontName = "Courier New"; fontSize = 12; ]
*)

ClearAll[appr4];
appr4[kt_]:= 
(
(* --- The expansion of the function F(x,y) into 
   the Taylor series with respect to (xc, yc) 
   point ------------------------------------- *)
    f[x_, y_]:=
(sf = fc + fx*(x - xc) + fy*(y - yc) +
1/2*fxx*(x - xc)^2 + fxy*(x - xc)*(y - yc) +
1/2*fyy*(y - yc)^2;
If[kt > 2, sf = sf +
1/6*fxxx*(x-xc)^3 + 1/2*fxxy*(x - xc)^2*(y - yc) +
1/2*fxyy*(x-xc)*(y-yc)^2+1/6*fyyy*(y-yc)^3]; sf );

(*  The difference operator under consideration  *)
      xks = (x2 - x1)/2;      yks = (y2 - y1)/2;
      xet = (x4 - x3)/2;      yet = (y4 - y3)/2;
(* - Jac is the jacobian of the transformation - *)
             Jac = xks*yet - xet*yks;
(*  Substitution of the Taylor series expansions *)
Print["Substitution of the Taylor series expansions"];
Dxhfnum = (1/2)*(f[x2, y2] - f[x1, y1])*yet -
          (1/2)*(f[x4, y4] - f[x3, y3])*yks;

			  Jac = Simplify[Jac];
OutputForm[Dxhfnum] >> ap4.m;
                       OutputForm[Jac] >>> ap4.m;

                   Dxhfnum = Expand[Dxhfnum];
   Dxhf = Dxhfnum/Jac;
Print["The difference operator expanded into Taylor",
" series has the form"];
			 Print[Dxhf];

(* -- Representation of the spatial coordinates of 
      points 1, 2, 3, 4 as the deviations from the
      center (xc, yc) of the Taylor expansions - *)
          x1 = xc + c1x*h;   y1 = yc + c1y*h;
          x2 = xc + c2x*h;   y2 = yc + c2y*h;
          x3 = xc + c3x*h;   y3 = yc + c3y*h;
          x4 = xc + c4x*h;   y4 = yc + c4y*h;
Print["Substitution of the coordinates of points 1,...,4"];
Print["into the expanded difference operator as the"];
Print["deviations from the (xc, yc) point."];
   Dxhfnum = Dxhfnum;   Dxhfnum = Expand[Dxhfnum];
   OutputForm["Dxhfnum = " Dxhfnum] >>> ap4.m;
 Jac = Jac; Jac = Expand[Jac]; Jac = Simplify[Jac];
   OutputForm["Jacobian = "Jac] >>> ap4.m;
   a2 = Coefficient[Jac, h, 2];
		 OutputForm[a2] >>> ap4.m;
Print["Determination of the coefficient of h^2 in the"];
Print["numerator of the expanded difference operator."];
r0 = Coefficient[Dxhfnum, h, 2]; r0 = Simplify[r0];
                OutputForm["r0 = "r0] >>> ap4.m;

Print["Determination of the coefficient of h^3 in the"];
Print["numerator of the expanded difference operator."];
r1 = Coefficient[Dxhfnum, h, 3]; r1 = Simplify[r1];
                OutputForm["r1 = "r1] >>> ap4.m;

Print["Determination of the coefficient of h^4 in the"];
Print["numerator of the expanded difference operator."];
r2 = Coefficient[Dxhfnum, h, 4];  r2 = Simplify[r2];
                OutputForm["r2 = "r2] >>> ap4.m;

Print["The coefficient of h^0 in the operator Dxhf is"];
       r0 = r0/a2;
Print[r0];
           OutputForm["r0 = " r0] >>> ap4.m;
Print["The coefficient of h^1 in the operator Dxhf is"];
       r1 = r1/a2;
Print[r1];
	  OutputForm["r1 = "r1] >>> ap4.m;
Print["The coefficient of h^2 in the operator Dxhf is"];
       r2 = r2/a2;
Print[r2];
	    OutputForm["r2 = "r2] >>> ap4.m;

(* ---- The particular case of square cells ---- *)
Print["The particular case of square cells"];
OutputForm["The particular case of square cells"]>>>ap4.m;
       c1x = -1; c1y = 0; c2x = 1; c2y = 0;
       c3x = 0; c3y = -1; c4x = 0; c4y = 1;
 r1 = r1; r1 = Simplify[r1];
Print["The coefficient of h in the operator Dxhf"];
Print["in the case of square cells is"];
Print[r1];
           OutputForm["r1 = "r1] >>> ap4.m;
 r2 = r2; r2 = Simplify[r2];
Print["The coefficient of h^2 in the operator Dxhf"];
Print["in the case of square cells is"];
Print[r2];
           OutputForm["r2 = "r2] >>> ap4.m; )
(*
^*)