(*^

::[	frontEndVersion = "Microsoft Windows Mathematica Notebook Front End Version 2.2";
	microsoftWindowsStandardFontEncoding;
	fontset = title, "Arial", 24, L0, center, nohscroll, bold;
	fontset = subtitle, "Arial", 18, L0, center, nohscroll, bold;
	fontset = subsubtitle, "Arial", 14, L0, center, nohscroll, bold;
	fontset = section, "Arial", 14, L0, bold, grayBox;
	fontset = subsection, "Arial", 12, L0, bold, blackBox;
	fontset = subsubsection, "Arial", 10, L0, bold, whiteBox;
	fontset = text, "Arial", 12, L0;
	fontset = smalltext, "Arial", 10, L0;
	fontset = input, "Courier New", 12, L0, nowordwrap, bold;
	fontset = output, "Courier New", 12, L0, nowordwrap;
	fontset = message, "Courier New", 10, L0, nowordwrap, R65280;
	fontset = print, "Courier New", 10, L0, nowordwrap;
	fontset = info, "Courier New", 10, L0, nowordwrap;
	fontset = postscript, "Courier New", 8, L0, nowordwrap;
	fontset = name, "Arial", 10, L0, nohscroll, italic, B65280;
	fontset = header, "Times New Roman", 10, L0, right, nohscroll;
	fontset = footer, "Times New Roman", 10, L0, right, nohscroll;
	fontset = help, "Arial", 10, L0, nohscroll;
	fontset = clipboard, "Arial", 12, L0, nohscroll;
	fontset = completions, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = graphics, "Courier New", 10, L0, nowordwrap, nohscroll;
	fontset = special1, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = special2, "Arial", 12, L0, center, nowordwrap, nohscroll;
	fontset = special3, "Arial", 12, L0, right, nowordwrap, nohscroll;
	fontset = special4, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = special5, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = leftheader, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = leftfooter, "Arial", 12, L0, nowordwrap, nohscroll;
	fontset = reserved1, "Courier New", 10, L0, nowordwrap, nohscroll;]
:[font = title; inactive; nohscroll; center; ]
Multi-Level Schemes
:[font = name; inactive; nohscroll; ]

                                  Victor G. Ganzha and Evgenii V. Vorozhtsov
:[font = section; inactive; ]
Impressum
:[font = special4; inactive; nowordwrap; nohscroll; ]

This Mathematica-Notebook is part of the book entitled
                                     V.G.Ganzha and E.V.Vorozhtsov
   Numerical Solutions For Partial Differential Equations: Problem Solving
   Using Mathematica.   CRC Press, Boca Raton, Ann Arbor, 1996.
:[font = subsection; inactive; ]
Copyright
:[font = special4; inactive; nowordwrap; nohscroll; ]

Numerical Solutions For Partial Differential Equations: Problem Solving
Using Mathematica.   CRC Press, Boca Raton, Ann Arbor, 1996.
:[font = section; inactive; ]
General Description
:[font = special4; inactive; nowordwrap; nohscroll; ]

The program  multlev.ma which follows below enables one to determine the 
 form of the matrix difference operator appearing as a result of the reduction
 of a scalar multi-level difference equation to a system of the two-level 
 difference equations .
     A more detailed description of the underlying symbolic-numerical method 
can be found in Section 2.8 of the above mentioned book.  
:[font = section; inactive; ]
User's Guide
:[font = subsection; inactive; ]
Step 1
:[font = special4; inactive; nowordwrap; nohscroll; ]
Specify the form of a difference scheme by modifying the body of the
function sch[  ] .

:[font = subsection; inactive; ]
Step 2
:[font = special4; inactive; nowordwrap; nohscroll; ]

Load and compile the program file beginning with the line
:[font = input; nowordwrap; ]

sch[j_, n_]:= u[j, n+1] - 2*u[j, n] + u[j, n - 1] -
:[font = section; inactive; ]
Program Listing
:[font = input; startGroup; nowordwrap; ]

sch[j_, n_]:= u[j, n+1] - 2*u[j, n] + u[j, n - 1] -
(c*dt/h)^2*(u[j+1,n] - 2*u[j, n] + u[j - 1, n]);
(* - The formula for the nondimensional variable 
     entering the difference equation: --------- *)
       rulecp = dt -> h*cp/c;
sc1 = sch[j, n];
Print["The difference equation"];
Print[sc1, " = 0"];
(* -- Introduction of the variable cp into the 
      difference scheme ------------------------ *)
 sc1 = sc1 /. rulecp;
OutputForm[sc1] >> tscr.m; 
(*  Determination of the number q of time layers *)
      utrt = u[k_, m_] -> T0[m - n];
       sc2 = sc1;
       sc2 = sc2 /. utrt;
OutputForm[sc2] >>> tscr.m;
	 nmin = 10; nmax = -10;
   Do[aj = Coefficient[sc2, T0[j]];
      If[aj===0, Goto[nexj]];
	If[j < nmin, nmin = j];
	  If[j > nmax, nmax = j];
	    Label[nexj],
    {j, -10, 10, 1}];
 q = nmax - nmin;
 Print["q = ",q, "; nmin = ", nmin, "; nmax = ",
        nmax];
(* Solution of the difference equation with respect
   to u[j,n + q]  *)
   utrt1 = u[k_, m_] -> u[k, m -nmin];
     sc3 = sc1 /. utrt1;
                     OutputForm[sc3] >>> tscr.m;
(* -- Introduction of the shift operators T[k] 
      along the x-axis, such that 
      T[k]*u[j,m] = u[j + k, m] --------------- *)
 utrx = u[k_, m_] -> T[k - j]*v[j, m];
  sc4 = sc3 /. utrx;
              sol = Solve[sc4 == 0, v[j, n + q]];
  up = v[j, n + q] /. sol;
    up = up /. T[0] -> 1;
                   OutputForm[up] >>> tscr.m;
  utrt2 = v[j_, m_] -> V[j, m - q + 1];
     up = up /. utrt2;
                    OutputForm[up] >>> tscr.m;
  utrt3 = V[j_, m_] -> w[n - m + 1];
    up1 = up /. utrt3; up1 = Simplify[up1];
     Do[Collect[up1, w[j]], {j,q}];
                       OutputForm[up1] >>> tscr.m;
(* ----- Generation of the qxq matrix C -------- *)
    CC = IdentityMatrix[q];
 Do[aj = Coefficient[up1, w[j]];
    CC = ReplacePart[CC, aj, {1, j}],
    {j,q}];
 celem[j_, k_] := If[k + 1 == j, 1, 0];
       Do[
          Do[  CC[[j,k]] = 0;
               CC[[j, k]] = celem[j, k],
                 {k, q}],
       {j, 2, q}];
Print["The expressions for the elements of the matrix C"];
  Do[
     Do[aj = CC[[j, k]];
 Print["C[[", j, ",", k, "]] = ", aj],
     {k, q}],
  {j, q}];
:[font = print; inactive; formatted; output; nowordwrap; ]
No Input Form Generated


;[o]
The difference equation
u[j, -1 + n] - 2 u[j, n] + u[j, 1 + n] - 
 
   2   2
  c  dt  (u[-1 + j, n] - 2 u[j, n] + u[1 + j, n])
  ----------------------------------------------- = 0
                         2
                        h
q = 2; nmin = -1; nmax = 1
The expressions for the elements of the matrix C
                    2     2           2
C[[1,1]] = {2 - 2 cp  + cp  T[-1] + cp  T[1]}
C[[1,2]] = {-1}
C[[2,1]] = 1
C[[2,2]] = 0
:[font = message; inactive; formatted; output; endGroup; nowordwrap; ]
Can't Format Cell



;[o]
General::spell1: 
   Possible spelling error: new symbol name "utrx"
     is similar to existing symbol "utrt".
^*)